#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e7 + 10;
bool sieve[MAXN];

vector <long long> primes;

long long power(long long base, long long exp) {
    if (exp == 0) return 1;
    if (exp % 2 == 0) {
        long long x = power(base, exp / 2);
        return x * x;
    }

    return base * power(base, exp - 1);
}

long long solve(long long n) {
    long long ans = 1;

    for (long long p : primes) {
        if (n % p) continue;
        long long cnt = 0;

        while (n % p == 0) {
            cnt++;
            n /= p;
        }

        ans *= (power(p, cnt + 1) - 1) / (p - 1);
    }

    if (n != 1) {
        ans *= n + 1;
    }

    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for (int i = 2; i < MAXN; i++) {
        if (sieve[i]) continue;
        primes.push_back(i);

        for (int j = 2 * i; j < MAXN; j += i) {
            sieve[j] = 1;
        }
    }

    int q;
    cin >> q;


    while (q--) {
        long long n;
        cin >> n;

        cout << solve(n) << '\n';
    }

    return 0;

}
