#include <iostream>
#include <algorithm>
#include <bitset>
using namespace std;

const int MAXN = 1e2 + 10;
long long a[10 * MAXN], b[10 * MAXN];
long long modulo;

long long dp[2][MAXN][2 * MAXN];
//bool choice[MAXN][MAXN][2 * MAXN];
bitset <2 * MAXN * MAXN * MAXN> choice;

/// Дадена редица b[i], искаме да намерим максималната сума на елементи, такава че тя е === x (mod m)



long long solve(long long n, long long k, long long rem) {
    for (int i = 0; i <= 1; i++) {
        for (int j = 0; j <= k; j++) {
            for (int l = 0; l < modulo; l++) {
                dp[i][j][l] = -1e15;
            }
        }
    }

    dp[0][0][0] = 0;

    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= k; j++) {
            for (int l = 0; l < modulo; l++) {
                long long new_rem = l - b[i];
                new_rem %= modulo;
                new_rem += modulo;
                new_rem %= modulo;

                long long variant_1 = dp[(i - 1) % 2][j][l];
                long long variant_2 = -1e15;
                if (j > 0) variant_2 = dp[(i - 1) % 2][j - 1][new_rem] + b[i];

                choice[i * MAXN * (2 * MAXN) + j * (2 * MAXN) + l] = variant_1 < variant_2;

                dp[i % 2][j][l] = max(variant_1, variant_2);
            }
        }
    }

    return dp[n % 2][k][rem];
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long n, k, sum_b = 0;
    cin >> n >> k;


    for (int i = 1; i <= n; i++) {
        cin >> b[i];

        sum_b += b[i];
    }

    if (k == 0) {
        if (sum_b % (n - 1)) {
            cout << -1 << '\n';
            return 0;
        }

        long long sum = sum_b / (n - 1);


        for (int i = 1; i <= n; i++) {
            a[i] = sum - b[i];

            if (a[i] <= 0) {
                cout << -1 << '\n';
                return 0;
            }
        }

        for (int i = 1; i <= n; i++) {
            cout << a[i] << ' ';
        }

        cout << '\n';
        return 0;
    }

    //sort(b + 1, b + n + 1);

    long long mn = 0;

    modulo = n + k - 1;
    long long rem = ((-sum_b) % modulo + modulo) % modulo;
    long long found = solve(n, k, rem);

    if (found <= 0) {
        cout << -1 << '\n';
        return 0;
    }

    long long sum = (found + sum_b) / (n + k - 1);

    for (int i = 1; i <= n; i++) {
        a[i] = sum - b[i];

        if (a[i] <= 0) {
            cout << -1 << '\n';
            return 0;
        }
    }

    for (int i = 1; i <= n; i++) {
        cout << a[i] << ' ';
    }

    cout << '\n';

    int cn = n, ck = k, crem = rem;

    while (cn > 0 && ck > 0) {
        if (choice[cn * MAXN * (2 * MAXN) + ck * (2 * MAXN) + crem]) {
            crem = ((crem - b[cn]) % modulo + modulo) % modulo;
            cout << sum - b[cn] << ' ';
            cn--;
            ck--;

        } else cn--;
    }

    return 0;

}




