#include <iostream>
#include <algorithm>
using namespace std;

const int MAXN = 5e1 + 10;
long long a[10 * MAXN], b[10 * MAXN];

long long modulo;

long long dp[MAXN][MAXN][2 * MAXN];
bool v[MAXN][MAXN][2 * MAXN];
bool choice[MAXN][MAXN][2 * MAXN];

long long f(long long n, long long k, long long rem) {
    if (n < 0) return -1e15;
    if (n == 0) return (k == 0 && rem == 0) ? 0 : -1e15;

    if (v[n][k][rem]) return dp[n][k][rem];
    v[n][k][rem] = 1;

    long long new_rem = rem - b[n];
    new_rem %= modulo;
    new_rem += modulo;
    new_rem %= modulo;

    long long variant_1 = f(n - 1, k, rem);
    long long variant_2 = f(n - 1, k - 1, new_rem) + b[n];

    choice[n][k][rem] = (variant_1 < variant_2);

    return dp[n][k][rem] = max(f(n - 1, k, rem), f(n - 1, k - 1, new_rem) + b[n]);
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long n, k, sum_b = 0;
    cin >> n >> k;


    for (int i = 1; i <= n; i++) {
        cin >> b[i];

        sum_b += b[i];
    }

    if (k == 0) {
        if (sum_b % (n - 1)) {
            cout << -1 << '\n';
            return 0;
        }

        long long sum = sum_b / (n - 1);


        for (int i = 1; i <= n; i++) {
            a[i] = sum - b[i];

            if (a[i] <= 0) {
                cout << -1 << '\n';
                return 0;
            }
        }

        for (int i = 1; i <= n; i++) {
            cout << a[i] << ' ';
        }

        cout << '\n';
        return 0;
    }

    //sort(b + 1, b + n + 1);

    long long mn = 0;

    modulo = n + k - 1;
    long long rem = ((-sum_b) % modulo + modulo) % modulo;
    long long found = f(n, k, rem);

    if (found <= 0) {
        cout << -1 << '\n';
        return 0;
    }

    long long sum = (found + sum_b) / (n + k - 1);

    for (int i = 1; i <= n; i++) {
        a[i] = sum - b[i];

        if (a[i] <= 0) {
            cout << -1 << '\n';
            return 0;
        }
    }

    for (int i = 1; i <= n; i++) {
        cout << a[i] << ' ';
    }

    cout << '\n';

    int cn = n, ck = k, crem = rem;

    while (cn > 0 && ck > 0) {
        if (choice[cn][ck][crem]) {
            crem = ((crem - b[cn]) % modulo + modulo) % modulo;
            cout << sum - b[cn] << ' ';
            cn--;
            ck--;

        } else cn--;
    }

    return 0;

}




